Subject: Re: [tram] TRAM, WebRTC and DHT

From: Marc Petit-Huguenin <[email-masked]>
Date: Sun, 9 Aug 2015 07:38:38 -0600

Hi Stephan,

On 07/29/2015 08:53 AM, Stefan Möhl wrote:
> If this is the wrong forum for my question, please accept my
> apologies!
> 
> If I understand things correctly, this IETF group is working on the
> next-gen STUN/TURN protocol. There has also been some work on using
> DHT, at least for STUN; see, i.e.
> http://www.labri.fr/perso/tad/download/rapport_PFE_pierre.pdf or
> https://www.google.se/url?sa=t&rct=j&q=&esrc=s&source=web&cd=1&cad=rja&uact=8&ved=0CCEQFjAAahUKEwijo8OK3_vGAhXGXCwKHWVaDcg&url=http%3A%2F%2Fmaidsafe.net%2FWhitepapers%2Fpdf%2FDHTbasedNATTraversal.pdf&ei=1V22VePkNca5sQHltLXADA&usg=AFQjCNGh2Fv1ig5-gPEV6O_kGeDkb8CRdA&sig2=UCrPnRo64-TG5-3DgYclqQ&bvm=bv.98717601,d.bGg
>
>  Since a strong motivation for TRAM, as I understand it, is the shift
> towards using STUN/TURN for WebRTC, and the big value in WebRTC is
> the almost serverless nature of WebRTC, I was wondering if this group
> is taking DHT into consideration? 

I do not think that the big value in WebRTC is that it is serverless - it is not.  The peer-to-peer nature of the media path between browsers is one of convenience, because using a centralized model requires resources and has qos consequences.  The one and only reason for WebRTC is to not have to install additional software, but the underlying model is still the same than before.

P2PSIP was an interesting approach to break that model, and we all know where it went.  A long time ago I did some preliminary work on how to use WebRTC with RELOAD, but it is near impossible to get any funding in this area, so I had to give up.

> If at least the signaling server
> and the STUN server could be shifted to DHT, WebRTC could become
> truly serverless for the majority of users that do not require a TURN
> server, and thereby extremely resilient!

P2PSIP did exactly that, by having TURN servers discoverable through a DHT (see RFC 6940 section 9).  Perhaps that should be added to draft-ietf-tram-turn-server-discovery.

- -- 
Marc Petit-Huguenin
Email: [email-masked]
Blog: http://blog.marc.petit-huguenin.org
Profile: http://www.linkedin.com/in/petithug